#!/usr/bin/env ansible-playbook
---
- name: Deploy MinIO Operator
  hosts: "{{ target_hosts }}"
  vars:
    target_hosts: localhost
  pre_tasks:
    - name: Check k8s_kubeconfig
      ansible.builtin.debug:
        var: k8s_kubeconfig
  tasks:
    - name: Deploy MinIO Operator
      ansible.builtin.import_role:
        name: minio
        tasks_from: deploy_minio_operator
        defaults_from: main
  environment:
    KUBECONFIG: "{{ k8s_kubeconfig | default(lookup('ansible.builtin.env', 'KUBECONFIG', default='/etc/kubernetes/admin.conf')) }}"
  tags:
    - minio_operator

- name: Deploy MinIO Tenants
  hosts: "{{ target_hosts }}"
  vars:
    target_hosts: localhost
  pre_tasks:
    - name: Check k8s_kubeconfig
      ansible.builtin.debug:
        var: k8s_kubeconfig
  tasks:
    - name: Deploy MinIO Tenant
      ansible.builtin.include_role:
        name: minio
        tasks_from: deploy_minio_tenant
        defaults_from: main
      vars:
        k8s_minio_tenant_release_name: "{{ item.k8s_minio_tenant_release_name | default(k8s_minio_default_tenant_release_name) }}"
        k8s_minio_tenant_namespace: "{{ item.k8s_minio_tenant_namespace | default(k8s_minio_default_tenant_namespace) }}"
        k8s_minio_tenant_chart_name: "{{ item.k8s_minio_tenant_chart_name | default(k8s_minio_default_tenant_chart_name) }}"
        k8s_minio_tenant_chart_version: "{{ item.k8s_minio_tenant_chart_version | default(k8s_minio_default_tenant_chart_version) }}"
        k8s_minio_tenant_image_tag: "{{ item.k8s_minio_tenant_image_tag | default(k8s_minio_default_tenant_image_tag) }}"
        k8s_minio_tenant_volumes: "{{ item.k8s_minio_tenant_volumes | default(k8s_minio_default_tenant_volumes) }}"
        k8s_minio_tenant_volume_size: "{{ item.k8s_minio_tenant_volume_size | default(k8s_minio_default_tenant_volume_size) }}"
        k8s_minio_tenant_servers: "{{ item.k8s_minio_tenant_servers | default(k8s_minio_default_tenant_servers) }}"
        k8s_minio_tenant_storage_class: "{{ item.k8s_minio_tenant_storage_class | default(k8s_minio_default_tenant_storage_class) }}"
        k8s_minio_s3_bucket_name: "{{ item.k8s_minio_s3_bucket_name | default(k8s_minio_default_s3_bucket_name) }}"
        k8s_minio_tenant_nodeport: "{{ item.k8s_minio_tenant_nodeport | default(k8s_minio_default_tenant_nodeport) }}"
        k8s_minio_access_key: "{{ item.k8s_minio_access_key }}"
        k8s_minio_secret_key: "{{ item.k8s_minio_secret_key }}"
        k8s_minio_username: "{{ item.k8s_minio_username }}"
        k8s_minio_password: "{{ item.k8s_minio_password }}"
      with_items: "{{ k8s_minio_tenants }}"
  environment:
    KUBECONFIG: "{{ k8s_kubeconfig | default(lookup('ansible.builtin.env', 'KUBECONFIG', default='/etc/kubernetes/admin.conf')) }}"
  tags:
    - minio_tenants
